//
// Mom.cpp 
// The Mom class
// v1.0 September 1, 2001
// Copyright (C) 2001 J. Ribelles
//

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#include <malloc.h>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <stdio.h>
#include "Mom.h"


// read an object from a file
void Mom::read (char * const filename) {

  ifstream in (filename);
  if (!in) {
    cerr << "I cannot read the file: " << filename << "\n";
    exit (1);
  }
  
  in >> nVertices >> nFaces >> nLods;

  vertexArray=  new MomVertex[nVertices+1];
  faceArray=    new MomFace[nFaces+1];
  controlArray= new MomControl[nLods+1];

  cout << "Vertices: " << nVertices  << endl
       << "Faces:    " << nFaces << endl
       << "Lods:     " << nLods << endl;
  
  int i, n= nLods- 1;
  int lastVertex= nVertices, firstVertex;
  int firstFace, lastFace= nFaces;
  
  while (n>= 0) {   // for each lod
    in >> controlArray[n];

    firstVertex= controlArray[n].getDeletedVertices();
    for (i= firstVertex; i< lastVertex; i++)
      in >> vertexArray[i];

    firstFace=  vertexArray[firstVertex]. getFaf();
    for (i= firstFace; i< lastFace; i++)
      in >> faceArray[i];

    lastFace= firstFace;
    lastVertex= firstVertex;
    n--;
  }

  resultArray=  (int *) calloc (nFaces*3, sizeof (int));

  cout << "File read." << endl;
}


// display a lod
int Mom::displayLod (const int Lod) {

  int deletedVertices, faf, generatedFaces, v2, v3;

  controlArray[Lod].get (deletedVertices, generatedFaces);
  faf= vertexArray[deletedVertices].getFaf();

  if (lastLod!= Lod) {

    int nFacesLod= generatedFaces- faf;
    int first= faf, last, init= deletedVertices, index= 0;

    lastLod= Lod;

    while (nFacesLod> 0) {
      last= vertexArray[init+1].getFaf();
      while ((first< last) && (faceArray[first].getId()< generatedFaces)) {
	faceArray[first].getVertices(v2, v3);
	vertexArray[init].paint();
	vertexArray[v2].paint();
	vertexArray[v3].paint();
	first++;
	nFacesLod--;
	resultArray[index++]= init;
	resultArray[index++]= v2;
	resultArray[index++]= v3;
      }
      init++;
      first= last;
    }
    lengthResultArray= index;
  } else {
    for (int i= 0; i< lengthResultArray; i++) 
      vertexArray[resultArray[i]].paint();
  }

  return (generatedFaces- faf);
}
