//
// Mom.h 
// Interface for the Mom class
// v1.0 September 1,  2001
// Copyright (C) 2001 J. Ribelles
//

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#ifndef MOM_H
#define MOM_H


#include "MomVertex.h"
#include "MomFace.h"
#include "MomControl.h"


class Mom {

 private:

  // basic data structure
  MomVertex  *vertexArray;     // pointer to the list of vertices
  MomFace    *faceArray;       // pointer to the list of faces
  MomControl *controlArray;    // pointer to the list of control

  int nVertices;  // number of vertices
  int nFaces;     // number of faces
  int nLods;      // number of lods
  int lastLod;    // last lod displayed
  int *resultArray; // data of the retrieved Lod
  int lengthResultArray; // its length

 public:

  // constructors
  Mom (void): nVertices (0), nFaces (0), nLods (0), lastLod(-1),
    vertexArray (NULL), faceArray (NULL), controlArray (NULL) {};
  
  // return the data of the class
  inline int getNLods (void) const     {return nLods;};

  // read a Mom model
  void read (char * const filename);

  // display a lod, return the number of faces painted
  int displayLod (const int Lod);
};


#endif
