//
// MomControl.h 
// Interface of MomControl class
// v1.0 September 1,  2001
// Copyright (C) 2001 J. Ribelles
//

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/


#ifndef MOM_CONTROL_H
#define MOM_CONTROL_H


#include <iostream.h>


// class control of a Mom representation
class MomControl {

 protected:

  short int deletedVertices; // number of deleted vertices
  short int generatedFaces;  // number of generated faces
  
public:

  // constructors
  MomControl (void): deletedVertices (-1), generatedFaces (-1) {};

  // to modify the data of the class
  void set (const short int dV, const short int gF) {
    deletedVertices= dV; generatedFaces= gF; };

  // to obtain the data of the class
  inline void get (int &dV, int &gF) const {
    dV= (int)deletedVertices; gF= (int)generatedFaces; };
  inline int getDeletedVertices (void) const {return (int) deletedVertices; };

  // input
  inline friend istream &operator >> (istream &in, MomControl &c) {
    short int gf, dv;
    in >> dv >> gf;
    c.set (dv, gf);
    return in;
  };
};


#endif

