//
// MomFace.h
// The MomFace class
// v1.0 September 1,  2001
// Copyright (C) 2001 J. Ribelles
//
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#ifndef MOM_FACE_H
#define MOM_FACE_H


#include <iostream.h>


// class face of a Mom representation
class MomFace {

 protected:

  int id;        // identifier of the face
  int v2, v3;    // the two pointers to the vertices (only two are needed)
  
 public:

  // constructors
  MomFace (void) : 
    id(-1), v2(0), v3(0) {};

  // to modify the data of the class
  inline void set (const int idFace, 
		   const int secondVertex, const int thirdVertex) {
    id= idFace; v2= secondVertex; v3= thirdVertex; };

  // to obtain the data of the class
  inline void getVertices (int &secondVertex, int &thirdVertex) {
    secondVertex= v2; thirdVertex= v3; };
  inline int getId (void) const {return id;};

  // input
  inline friend istream &operator >> (istream &in, MomFace &f) {
    int _id, _v2, _v3;
    in >> _id >> _v2 >> _v3;
    f.set (_id, _v2, _v3);
    return in;
  };
};


#endif

