//
// MomVertex.h 
// Interface for the MomVertex class
// v1.0 September 1,  2001
// Copyright (C) 2001 J. Ribelles
//

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#ifndef MOM_VERTEX_H
#define MOM_VERTEX_H


#include <iostream.h>
#include <GL/glut.h>


// vertex class of a Mom representation
class MomVertex {

 protected:

  float    coords[3];            // x, y, z, of the vertex
  int      firstAssociatedFace;  // the first associated face to the vertex
  
 public:

  // constructors
  MomVertex (void) {
    coords[0]= 0.0f; coords[1]= 0.0f; coords[2]= 0.0f; 
    firstAssociatedFace= -1; };
  
  // to modify the data of the class
  inline void set (const float x, const float y, const float z, const int faf) 
    { coords[0]= x; coords[1]= y; coords[2]= z; firstAssociatedFace= faf;};

  // to obtain the data of the class
  inline int  getFaf (void) const {return firstAssociatedFace;};

  // to paint the vertex using OpenGL
  inline void paint (void)  {glVertex3fv (coords);};

  // input
  inline friend istream &operator >> (istream &in, MomVertex &v) {
    int faf;
    float x, y, z;
    in >> x >> y >> z >> faf;
    v.set (x, y, z, faf);
    return in;
  };
};


#endif

